<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>StrictContentLengthStrategy xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/http/impl/entity/StrictContentLengthStrategy.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.entity;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpException;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpMessage;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpVersion;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ProtocolException;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.Immutable;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.ContentLengthStrategy;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HTTP;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.Args;
<a class="jxr_linenumber" name="39" href="#39">39</a>  
<a class="jxr_linenumber" name="40" href="#40">40</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="41" href="#41">41</a>  <em class="jxr_javadoccomment"> * The strict implementation of the content length strategy. This class</em>
<a class="jxr_linenumber" name="42" href="#42">42</a>  <em class="jxr_javadoccomment"> * will throw {@link ProtocolException} if it encounters an unsupported</em>
<a class="jxr_linenumber" name="43" href="#43">43</a>  <em class="jxr_javadoccomment"> * transfer encoding or a malformed &lt;code&gt;Content-Length&lt;/code&gt; header</em>
<a class="jxr_linenumber" name="44" href="#44">44</a>  <em class="jxr_javadoccomment"> * value.</em>
<a class="jxr_linenumber" name="45" href="#45">45</a>  <em class="jxr_javadoccomment"> * &lt;p&gt;</em>
<a class="jxr_linenumber" name="46" href="#46">46</a>  <em class="jxr_javadoccomment"> * This class recognizes "chunked" and "identitiy" transfer-coding only.</em>
<a class="jxr_linenumber" name="47" href="#47">47</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="48" href="#48">48</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="49" href="#49">49</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="50" href="#50">50</a>  @Immutable
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/impl/entity/StrictContentLengthStrategy.html">StrictContentLengthStrategy</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../org/apache/http/entity/ContentLengthStrategy.html">ContentLengthStrategy</a> {
<a class="jxr_linenumber" name="52" href="#52">52</a>  
<a class="jxr_linenumber" name="53" href="#53">53</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/impl/entity/StrictContentLengthStrategy.html">StrictContentLengthStrategy</a> INSTANCE = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/impl/entity/StrictContentLengthStrategy.html">StrictContentLengthStrategy</a>();
<a class="jxr_linenumber" name="54" href="#54">54</a>  
<a class="jxr_linenumber" name="55" href="#55">55</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> implicitLen;
<a class="jxr_linenumber" name="56" href="#56">56</a>  
<a class="jxr_linenumber" name="57" href="#57">57</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="58" href="#58">58</a>  <em class="jxr_javadoccomment">     * Creates &lt;tt&gt;StrictContentLengthStrategy&lt;/tt&gt; instance with the given length used per default</em>
<a class="jxr_linenumber" name="59" href="#59">59</a>  <em class="jxr_javadoccomment">     * when content length is not explicitly specified in the message.</em>
<a class="jxr_linenumber" name="60" href="#60">60</a>  <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="61" href="#61">61</a>  <em class="jxr_javadoccomment">     * @param implicitLen implicit content length.</em>
<a class="jxr_linenumber" name="62" href="#62">62</a>  <em class="jxr_javadoccomment">     *</em>
<a class="jxr_linenumber" name="63" href="#63">63</a>  <em class="jxr_javadoccomment">     * @since 4.2</em>
<a class="jxr_linenumber" name="64" href="#64">64</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/impl/entity/StrictContentLengthStrategy.html">StrictContentLengthStrategy</a>(<strong class="jxr_keyword">int</strong> implicitLen) {
<a class="jxr_linenumber" name="66" href="#66">66</a>          <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="67" href="#67">67</a>          <strong class="jxr_keyword">this</strong>.implicitLen = implicitLen;
<a class="jxr_linenumber" name="68" href="#68">68</a>      }
<a class="jxr_linenumber" name="69" href="#69">69</a>  
<a class="jxr_linenumber" name="70" href="#70">70</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment">     * Creates &lt;tt&gt;StrictContentLengthStrategy&lt;/tt&gt; instance. {@link ContentLengthStrategy#IDENTITY}</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <em class="jxr_javadoccomment">     * is used per default when content length is not explicitly specified in the message.</em>
<a class="jxr_linenumber" name="73" href="#73">73</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="74" href="#74">74</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/impl/entity/StrictContentLengthStrategy.html">StrictContentLengthStrategy</a>() {
<a class="jxr_linenumber" name="75" href="#75">75</a>          <strong class="jxr_keyword">this</strong>(IDENTITY);
<a class="jxr_linenumber" name="76" href="#76">76</a>      }
<a class="jxr_linenumber" name="77" href="#77">77</a>  
<a class="jxr_linenumber" name="78" href="#78">78</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">long</strong> determineLength(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/HttpMessage.html">HttpMessage</a> message) <strong class="jxr_keyword">throws</strong> HttpException {
<a class="jxr_linenumber" name="79" href="#79">79</a>          Args.notNull(message, <span class="jxr_string">"HTTP message"</span>);
<a class="jxr_linenumber" name="80" href="#80">80</a>          <em class="jxr_comment">// Although Transfer-Encoding is specified as a list, in practice</em>
<a class="jxr_linenumber" name="81" href="#81">81</a>          <em class="jxr_comment">// it is either missing or has the single value "chunked". So we</em>
<a class="jxr_linenumber" name="82" href="#82">82</a>          <em class="jxr_comment">// treat it as a single-valued header here.</em>
<a class="jxr_linenumber" name="83" href="#83">83</a>          <a href="../../../../../org/apache/http/Header.html">Header</a> transferEncodingHeader = message.getFirstHeader(HTTP.TRANSFER_ENCODING);
<a class="jxr_linenumber" name="84" href="#84">84</a>          <strong class="jxr_keyword">if</strong> (transferEncodingHeader != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="85" href="#85">85</a>              String s = transferEncodingHeader.getValue();
<a class="jxr_linenumber" name="86" href="#86">86</a>              <strong class="jxr_keyword">if</strong> (HTTP.CHUNK_CODING.equalsIgnoreCase(s)) {
<a class="jxr_linenumber" name="87" href="#87">87</a>                  <strong class="jxr_keyword">if</strong> (message.getProtocolVersion().lessEquals(HttpVersion.HTTP_1_0)) {
<a class="jxr_linenumber" name="88" href="#88">88</a>                      <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/ProtocolException.html">ProtocolException</a>(
<a class="jxr_linenumber" name="89" href="#89">89</a>                              <span class="jxr_string">"Chunked transfer encoding not allowed for "</span> +
<a class="jxr_linenumber" name="90" href="#90">90</a>                              message.getProtocolVersion());
<a class="jxr_linenumber" name="91" href="#91">91</a>                  }
<a class="jxr_linenumber" name="92" href="#92">92</a>                  <strong class="jxr_keyword">return</strong> CHUNKED;
<a class="jxr_linenumber" name="93" href="#93">93</a>              } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (HTTP.IDENTITY_CODING.equalsIgnoreCase(s)) {
<a class="jxr_linenumber" name="94" href="#94">94</a>                  <strong class="jxr_keyword">return</strong> IDENTITY;
<a class="jxr_linenumber" name="95" href="#95">95</a>              } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="96" href="#96">96</a>                  <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/ProtocolException.html">ProtocolException</a>(
<a class="jxr_linenumber" name="97" href="#97">97</a>                          <span class="jxr_string">"Unsupported transfer encoding: "</span> + s);
<a class="jxr_linenumber" name="98" href="#98">98</a>              }
<a class="jxr_linenumber" name="99" href="#99">99</a>          }
<a class="jxr_linenumber" name="100" href="#100">100</a>         <a href="../../../../../org/apache/http/Header.html">Header</a> contentLengthHeader = message.getFirstHeader(HTTP.CONTENT_LEN);
<a class="jxr_linenumber" name="101" href="#101">101</a>         <strong class="jxr_keyword">if</strong> (contentLengthHeader != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="102" href="#102">102</a>             String s = contentLengthHeader.getValue();
<a class="jxr_linenumber" name="103" href="#103">103</a>             <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="104" href="#104">104</a>                 <strong class="jxr_keyword">long</strong> len = Long.parseLong(s);
<a class="jxr_linenumber" name="105" href="#105">105</a>                 <strong class="jxr_keyword">if</strong> (len &lt; 0) {
<a class="jxr_linenumber" name="106" href="#106">106</a>                     <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/ProtocolException.html">ProtocolException</a>(<span class="jxr_string">"Negative content length: "</span> + s);
<a class="jxr_linenumber" name="107" href="#107">107</a>                 }
<a class="jxr_linenumber" name="108" href="#108">108</a>                 <strong class="jxr_keyword">return</strong> len;
<a class="jxr_linenumber" name="109" href="#109">109</a>             } <strong class="jxr_keyword">catch</strong> (NumberFormatException e) {
<a class="jxr_linenumber" name="110" href="#110">110</a>                 <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/ProtocolException.html">ProtocolException</a>(<span class="jxr_string">"Invalid content length: "</span> + s);
<a class="jxr_linenumber" name="111" href="#111">111</a>             }
<a class="jxr_linenumber" name="112" href="#112">112</a>         }
<a class="jxr_linenumber" name="113" href="#113">113</a>         <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.implicitLen;
<a class="jxr_linenumber" name="114" href="#114">114</a>     }
<a class="jxr_linenumber" name="115" href="#115">115</a> 
<a class="jxr_linenumber" name="116" href="#116">116</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

